<template>
  <b-row>
    <b-colxx class="disable-text-selection">
      <b-row>
        <b-colxx xxs="12">
          <h1>All Articles</h1>

          <div class="separator mb-5" />
        </b-colxx>
      </b-row>
      <template>
        <div class="text-center">
          <div class="row d-flex justify-content-center">
            <a
              v-for="item in pageOfItems"
              :key="item.id"
              :href="item.link"
              target="_blank"
              class="vuetable col-md-5 text-center m-1"
            >
              <b-card :title="item.title" tag="article" class="m-2">
                <b-card-text class="w-100"> By {{ item.author }} </b-card-text>
              </b-card>
            </a>
          </div>
          <div class="w-100 pb-2 pt-3">
              <jw-pagination :items="items" @changePage="onChangePage"></jw-pagination>
          </div>
        </div>
      </template>

      <v-contextmenu ref="contextmenu" @contextmenu="handleContextmenu">
        <v-contextmenu-item @click="onContextCopy()"
          ><i class="simple-icon-docs" /> <span>Copy</span></v-contextmenu-item
        >
        <v-contextmenu-item @click="onContextArchive()"
          ><i class="simple-icon-drawer" />
          <span>Move to archive</span></v-contextmenu-item
        >
        <v-contextmenu-item @click="onContextDelete()"
          ><i class="simple-icon-trash" />
          <span>Delete</span></v-contextmenu-item
        >
      </v-contextmenu>
    </b-colxx>
  </b-row>
</template>

<script>
import { DataListIcon, ThumbListIcon, ImageListIcon } from '@/components/Svg'
import vSelect from 'vue-select'
import 'vue-select/dist/vue-select.css'
import Vue from 'vue'
import axios from 'axios'
import JwPagination from 'jw-vue-pagination'
Vue.component('jw-pagination', JwPagination)
import ImageListItem from '@/components/Listing/ImageListItem'
import ThumbListItem from '@/components/Listing/ThumbListItem'
import DataListItem from '@/components/Listing/DataListItem'
import { apiUrl } from '@/constants/config'

export default {
  components: {
    DataListIcon,
    ThumbListIcon,
    ImageListIcon,
    vSelect,
    ImageListItem,
    ThumbListItem,
    DataListItem,
  },
  props: {
    pageSize: {
      type: Number,
      default: 8,
    },
  },
  data() {
    return {
      isLoad: false,
      pageOfItems: [],

      apiBase: apiUrl + '/api/articles',
      displayMode: 'image',
      sort: { column: 'title', label: 'Product Name' },
      sortOptions: [
        { column: 'title', label: 'Product Name' },
        { column: 'category', label: 'Category' },
        { column: 'status', label: 'Status' },
      ],
      page: 1,
      perPage: 6,
      search: '',
      lastPage: 0,
      items: [],
      pageSizes: [4, 8, 12],
      selectedItems: [],
      categories: [
        { label: 'Cakes', value: 'Cakes' },
        { label: 'Cupcakes', value: 'Cupcakes' },
        { label: 'Desserts', value: 'Desserts' },
      ],
      statuses: [
        { text: 'ON HOLD', value: 'ON HOLD' },
        { text: 'PROCESSED', value: 'PROCESSED' },
      ],
      newItem: {
        title: '',
        category: '',
        description: '',
        status: '',
      },
    }
  },
  methods: {
    onAddToFavorites() {
      // console.log(this.selectedItems, 'tag sel')
    },
    onChangePage(pageOfItems) {
      // update page of items
      this.pageOfItems = pageOfItems
    },
    loadItems() {
      this.isLoad = false
      Vue.prototype.$http
        .get(this.apiUrl)
        .then((response) => {
          return response.data
        })
        .then((res) => {
          this.items = res
          // console.log(this.items, 'tag res')
          this.perPage = res.per_page
          this.selectedItems = []
          this.lastPage = res.last_page
          this.isLoad = true
        })
    },
    hideModal(refname) {
      this.$refs[refname].hide()
    },
    changeDisplayMode(displayType) {
      this.displayMode = displayType
    },
    changePageSize(perPage) {
      this.perPage = perPage
    },
    changeOrderBy(sort) {
      this.sort = sort
    },
    addNewItem() {
      // console.log('adding item : ', this.newItem)
    },
    selectAll(isToggle) {
      if (this.selectedItems.length >= this.items.length) {
        if (isToggle) {
          this.selectedItems = []
        }
      } else {
        this.selectedItems = this.items.map((x) => x.id)
      }
    },
    selectSome(id, isToggle) {
      if (isToggle) {
        this.selectedItems.push(id)
      }
    },
    keymap(event) {
      switch (event.srcKey) {
        case 'select':
          this.selectAll(false)
          break
        case 'undo':
          this.selectedItems = []
          break
      }
    },
    getIndex(value, arr, prop) {
      for (var i = 0; i < arr.length; i++) {
        if (arr[i][prop] === value) {
          return i
        }
      }
      return -1
    },
    toggleItem(event, itemId) {
      // console.log('yes')
      if (event.shiftKey && this.selectedItems.length > 0) {
        let itemsForToggle = this.items
        var start = this.getIndex(itemId, itemsForToggle, 'id')
        var end = this.getIndex(
          this.selectedItems[this.selectedItems.length - 1],
          itemsForToggle,
          'id'
        )
        itemsForToggle = itemsForToggle.slice(
          Math.min(start, end),
          Math.max(start, end) + 1
        )
        this.selectedItems.push(
          ...itemsForToggle.map((item) => {
            return item.id
          })
        )
      } else {
        if (this.selectedItems.includes(itemId)) {
          this.selectedItems = this.selectedItems.filter((x) => x !== itemId)
        } else {
          this.selectedItems.push(itemId)
        }
      }
    },
    handleContextmenu(vnode) {
      if (!this.selectedItems.includes(vnode.key)) {
        this.selectedItems = [vnode.key]
      }
    },
    onContextCopy() {
      // console.log(
      //   'context menu item clicked - Copy Items: ',
      //   this.selectedItems
      // )
    },
    onContextArchive() {
      // console.log(
      //   'context menu item clicked - Move to Archive Items: ',
      //   this.selectedItems
      // )
    },
    onContextDelete() {
      // console.log(
      //   'context menu item clicked - Delete Items: ',
      //   this.selectedItems
      // )
    },
    linkGen(pageNum) {
      return '#page-' + pageNum
    },
  },
  computed: {
    isSelectedAll() {
      return this.selectedItems.length >= this.items.length
    },
    isAnyItemSelected() {
      return (
        this.selectedItems.length > 0 &&
        this.selectedItems.length < this.items.length
      )
    },
    apiUrl() {
      return `${this.apiBase}?sort=${this.sort.column}&page=${this.page}&per_page=${this.perPage}&search=${this.search}`
    },
  },
  watch: {
    search() {
      this.page = 1
    },
    apiUrl() {
      this.loadItems()
    },
  },
  mounted() {
    this.loadItems()
  },
}
</script>

<style scoped>
ul.pagination {
  display: flex !important;
  justify-content: center !important;
}

.card-title {
  display: -webkit-box;
  -webkit-line-clamp: 2; /* number of lines to show */
  -webkit-box-orient: vertical;
  overflow: hidden;
  text-overflow: ellipsis;
}

.card-body {
  height: 150px;
}
</style>